
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#中反射的概念及其使用（转） / 憋错料</title>

    <meta name="description" content="C#中反射的概念及其使用（转） 提纲:1. 什么是反射2. 命名空间与装配件的关系3. 运行期得到类型信息有什么用4. 如何使用反射获取类型5. 如何根据类型来动态创建对象6. 如何获取方法以及动态调用方法7. 动态创建委托 1.什么是反射        Reflection,中文翻译为反射.        这是.Net中获取运行时类型信息的方式,.Net的应用程序由几个部分:'程序集(Assembly)'.'模块(Module)'.'类型 (class)'组成,而反射提供一种编程的方式,让程序员可以在程序运行期获得这几个组成">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#中反射的概念及其使用（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>提纲：<br />1、 什么是反射<br />2、 命名空间与装配件的关系<br />3、 运行期得到类型信息有什么用<br />4、 如何使用反射获取类型<br />5、 如何根据类型来动态创建对象<br />6、 如何获取方法以及动态调用方法<br />7、 动态创建委托</p>
<p><strong>1、什么是反射</strong><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Reflection，中文翻译为反射。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这是.Net中获取运行时类型信息的方式，.Net的应用程序由几个部分：‘程序集(Assembly)’、‘模块(Module)’、‘类型 (class)’组成，而反射提供一种编程的方式，让程序员可以在程序运行期获得这几个组成部分的相关信息，例如：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Assembly类可以获得正在运行的装配件信息，也可以动态的加载装配件，以及在装配件中查找类型信息，并创建该类型的实例。<br />Type类可以获得对象的类型信息，此信息包含对象的所有要素：方法、构造器、属性等等，通过Type类可以得到这些要素的信息，并且调用之。<br />MethodInfo包含方法的信息，通过这个类可以得到方法的名称、参数、返回值等，并且可以调用之。<br />诸如此类，还有FieldInfo、EventInfo等等，这些类都包含在System.Reflection命名空间下。</p>
<p><strong>2、命名空间与装配件的关系</strong><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 很多人对这个概念可能还是很不清晰，对于合格的.Net程序员，有必要对这点进行澄清。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 命名空间类似与Java的包，但又不完全等同，因为Java的包必须按照目录结构来放置，命名空间则不需要。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 装配件是.Net应用程序执行的最小单位，编译出来的.dll、.exe都是装配件。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 装配件和命名空间的关系不是一一对应，也不互相包含，一个装配件里面可以有多个命名空间，一个命名空间也可以在多个装配件中存在，这样说可能有点模糊，举个例子：<br />装配件A：<br />namespace&nbsp;&nbsp; N1<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; AC1&nbsp;&nbsp; {…}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; AC2&nbsp;&nbsp; {…}<br />}<br />namespace&nbsp;&nbsp; N2<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; AC3&nbsp;&nbsp; {…}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; AC4{…}<br />}<br />装配件B：<br />namespace&nbsp;&nbsp; N1<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; BC1&nbsp;&nbsp; {…}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; BC2&nbsp;&nbsp; {…}<br />}<br />namespace&nbsp;&nbsp; N2<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; BC3&nbsp;&nbsp; {…}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; BC4{…}<br />}<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这两个装配件中都有N1和N2两个命名空间，而且各声明了两个类，这样是完全可以的，然后我们在一个应用程序中引用装配件A，那么在这个应用程序中，我们能看到N1下面的类为AC1和AC2，N2下面的类为AC3和AC4。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 接着我们去掉对A的引用，加上对B的引用，那么我们在这个应用程序下能看到的N1下面的类变成了BC1和BC2，N2下面也一样。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 如果我们同时引用这两个装配件，那么N1下面我们就能看到四个类：AC1、AC2、BC1和BC2。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 到这里，我们可以清楚一个概念了，命名空间只是说明一个类型是那个族的，比如有人是汉族、有人是回族；而装配件表明一个类型住在哪里，比如有人住在北京、有人住在上海；那么北京有汉族人，也有回族人，上海有汉族人，也有回族人，这是不矛盾的。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 上面我们说了，装配件是一个类型居住的地方，那么在一个程序中要使用一个类，就必须告诉编译器这个类住在哪儿，编译器才能找到它，也就是说必须引用该装配件。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 那么如果在编写程序的时候，也许不确定这个类在哪里，仅仅只是知道它的名称，就不能使用了吗？答案是可以，这就是反射了，就是在程序运行的时候提供该类型的地址，而去找到它。<br />有兴趣的话，接着往下看吧。<br /><strong>3、运行期得到类型信息有什么用</strong><br />&nbsp;&nbsp;&nbsp; 有人也许疑问，既然在开发时就能够写好代码，干嘛还放到运行期去做，不光繁琐，而且效率也受影响。<br />这就是个见仁见智的问题了，就跟早绑定和晚绑定一样，应用到不同的场合。有的人反对晚绑定，理由是损耗效率，但是很多人在享受虚函数带来的好处的时侯还没有意识到他已经用上了晚绑定。这个问题说开去，不是三言两语能讲清楚的，所以就点到为止了。<br />&nbsp;&nbsp;&nbsp; 我的看法是，晚绑定能够带来很多设计上的便利，合适的使用能够大大提高程序的复用性和灵活性，但是任何东西都有两面性，使用的时侯，需要再三衡量。<br />接着说，运行期得到类型信息到底有什么用呢？<br />还是举个例子来说明，很多软件开发者喜欢在自己的软件中留下一些接口，其他人可以编写一些插件来扩充软件的功能，比如我有一个媒体播放器，我希望以后可以很方便的扩展识别的格式，那么我声明一个接口：<br />public&nbsp;&nbsp; interface&nbsp;&nbsp; IMediaFormat<br />{<br />&nbsp;&nbsp;&nbsp; string&nbsp;&nbsp; Extension&nbsp;&nbsp; {get;}<br />&nbsp;&nbsp;&nbsp; Decoder&nbsp;&nbsp; GetDecoder();<br />}<br />这个接口中包含一个Extension属性，这个属性返回支持的扩展名，另一个方法返回一个解码器的对象（这里我假设了一个Decoder的类，这个类提供把文件流解码的功能，扩展插件可以派生之），通过解码器对象我就可以解释文件流。<br />那么我规定所有的解码插件都必须派生一个解码器，并且实现这个接口，在GetDecoder方法中返回解码器对象，并且将其类型的名称配置到我的配置文件里面。<br />这样的话，我就不需要在开发播放器的时侯知道将来扩展的格式的类型，只需要从配置文件中获取现在所有解码器的类型名称，而动态的创建媒体格式的对象，将其转换为IMediaFormat接口来使用。<br />这就是一个反射的典型应用。</p>
<p><strong>4、如何使用反射获取类型</strong><br />&nbsp;&nbsp;&nbsp; 首先我们来看如何获得类型信息。<br />&nbsp;&nbsp;&nbsp; 获得类型信息有两种方法，一种是得到实例对象<br />&nbsp;&nbsp;&nbsp; 这个时侯我仅仅是得到这个实例对象，得到的方式也许是一个object的引用，也许是一个接口的引用，但是我并不知道它的确切类型，我需要了解，那么就可以通过调用System.Object上声明的方法GetType来获取实例对象的类型对象，比如在某个方法内，我需要判断传递进来的参数是否实现了某个接口，如果实现了，则调用该接口的一个方法：<br />…<br />public&nbsp;&nbsp; void&nbsp;&nbsp; Process(&nbsp;&nbsp; object&nbsp;&nbsp; processObj&nbsp;&nbsp; )<br />{<br />&nbsp;&nbsp;&nbsp; Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; processsObj.GetType();<br />&nbsp;&nbsp;&nbsp; if(&nbsp;&nbsp; t.GetInterface(“ITest”)&nbsp;&nbsp; !=null&nbsp;&nbsp; )<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; …<br />}<br />…<br />&nbsp;&nbsp; 另外一种获取类型的方法是通过Type.GetType以及Assembly.GetType方法，如：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType(“System.String”);<br />&nbsp;&nbsp; 需要注意的是，前面我们讲到了命名空间和装配件的关系，要查找一个类，必须指定它所在的装配件，或者在已经获得的Assembly实例上面调用GetType。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 本装配件中类型可以只写类型名称，另一个例外是mscorlib.dll，这个装配件中声明的类型也可以省略装配件名称（.Net装配件编译的时候，默认都引用了mscorlib.dll，除非在编译的时候明确指定不引用它），比如：<br />&nbsp;&nbsp;&nbsp;&nbsp; System.String是在mscorlib.dll中声明的，上面的Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType(“System.String”)是正确的<br />&nbsp;&nbsp;&nbsp;&nbsp; System.Data.DataTable是在System.Data.dll中声明的，那么：<br />Type.GetType(“System.Data.DataTable”)就只能得到空引用。<br />必须：Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType("System.Data.DataTable,System.Data,Version=1.0.3300.0,&nbsp;&nbsp; Culture=neutral,&nbsp;&nbsp; PublicKeyToken=b77a5c561934e089");<br />&nbsp;&nbsp;&nbsp;&nbsp; 这样才可以，大家可以看下面这个帖子：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; http://expert.csdn.net/Expert/topic/2210/2210762.xml?temp=.1919977&nbsp;&nbsp;&nbsp; qqchen的回答很精彩</p>
<p><strong>5、如何根据类型来动态创建对象</strong><br />&nbsp;&nbsp;&nbsp; System.Activator提供了方法来根据类型动态创建对象，比如创建一个DataTable：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType("System.Data.DataTable,System.Data,Version=1.0.3300.0,&nbsp;&nbsp; Culture=neutral,&nbsp;&nbsp; PublicKeyToken=b77a5c561934e089");<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; DataTable&nbsp;&nbsp; table&nbsp;&nbsp; =&nbsp;&nbsp; (DataTable)Activator.CreateInstance(t);</p>
<p>例二：根据有参数的构造器创建对象<br />namespace&nbsp;&nbsp; TestSpace&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; TestClass<br />&nbsp;&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; private&nbsp;&nbsp; string&nbsp;&nbsp; _value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; TestClass(string&nbsp;&nbsp; value)&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; _value=value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp; }<br />}<br />…<br />Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType(“TestSpace.TestClass”);<br />Object[]&nbsp;&nbsp; constructParms&nbsp;&nbsp; =&nbsp;&nbsp; new&nbsp;&nbsp; object[]&nbsp;&nbsp; {“hello”};&nbsp;&nbsp; //构造器参数<br />TestClass&nbsp;&nbsp; obj&nbsp;&nbsp; =&nbsp;&nbsp; (TestClass)Activator.CreateInstance(t,constructParms);<br />…<br />把参数按照顺序放入一个Object数组中即可</p>
<p><strong>6、如何获取方法以及动态调用方法</strong><br />namespace&nbsp;&nbsp; TestSpace<br />{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; TestClass&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; private&nbsp;&nbsp; string&nbsp;&nbsp; _value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; TestClass()&nbsp;&nbsp; { }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; TestClass(string&nbsp;&nbsp; value)&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; _value&nbsp;&nbsp; =&nbsp;&nbsp; value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; string&nbsp;&nbsp; GetValue(&nbsp;&nbsp; string&nbsp;&nbsp; prefix&nbsp;&nbsp; )&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if(&nbsp;&nbsp; _value==null&nbsp;&nbsp; )<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return&nbsp;&nbsp; "NULL";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; else<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return&nbsp;&nbsp; prefix+"&nbsp;&nbsp; :&nbsp;&nbsp; "+_value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; string&nbsp;&nbsp; Value&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; set&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; _value=value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; get&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if(&nbsp;&nbsp; _value==null&nbsp;&nbsp; )<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return&nbsp;&nbsp; "NULL";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; else<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return&nbsp;&nbsp; _value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />}<br />&nbsp;&nbsp;&nbsp; 上面是一个简单的类，包含一个有参数的构造器，一个GetValue的方法，一个Value属性，我们可以通过方法的名称来得到方法并且调用之，如：<br />//获取类型信息<br />Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType("TestSpace.TestClass");<br />//构造器的参数<br />object[]&nbsp;&nbsp; constuctParms&nbsp;&nbsp; =&nbsp;&nbsp; new&nbsp;&nbsp; object[]{"timmy"};<br />//根据类型创建对象<br />object&nbsp;&nbsp; dObj&nbsp;&nbsp; =&nbsp;&nbsp; Activator.CreateInstance(t,constuctParms);<br />//获取方法的信息<br />MethodInfo&nbsp;&nbsp; method&nbsp;&nbsp; =&nbsp;&nbsp; t.GetMethod("GetValue");<br />//调用方法的一些标志位，这里的含义是Public并且是实例方法，这也是默认的值<br />BindingFlags&nbsp;&nbsp; flag&nbsp;&nbsp; =&nbsp;&nbsp; BindingFlags.Public&nbsp;&nbsp; |&nbsp;&nbsp; BindingFlags.Instance;<br />//GetValue方法的参数<br />object[]&nbsp;&nbsp; parameters&nbsp;&nbsp; =&nbsp;&nbsp; new&nbsp;&nbsp; object[]{"Hello"};<br />//调用方法，用一个object接收返回值<br />object&nbsp;&nbsp; returnValue&nbsp;&nbsp; =&nbsp;&nbsp; method.Invoke(dObj,flag,Type.DefaultBinder,parameters,null);<br />属性与方法的调用大同小异，大家也可以参考MSDN</p>
<p><strong>7、动态创建委托</strong><br />&nbsp;&nbsp;&nbsp; 委托是C#中实现事件的基础，有时候不可避免的要动态的创建委托，实际上委托也是一种类型：System.Delegate，所有的委托都是从这个类派生的<br />&nbsp;&nbsp;&nbsp; System.Delegate提供了一些静态方法来动态创建一个委托，比如一个委托：<br />namespace&nbsp;&nbsp; TestSpace&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; delegate&nbsp;&nbsp; string&nbsp;&nbsp; TestDelegate(string&nbsp;&nbsp; value);<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; class&nbsp;&nbsp; TestClass&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; TestClass()&nbsp;&nbsp; { }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; public&nbsp;&nbsp; void&nbsp;&nbsp; GetValue(string&nbsp;&nbsp; value)&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return&nbsp;&nbsp; value;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />}<br />使用示例：<br />TestClass&nbsp;&nbsp; obj&nbsp;&nbsp; =&nbsp;&nbsp; new&nbsp;&nbsp; TestClass();</p>
<p>//获取类型，实际上这里也可以直接用typeof来获取类型<br />Type&nbsp;&nbsp; t&nbsp;&nbsp; =&nbsp;&nbsp; Type.GetType(“TestSpace.TestClass”);<br />//创建代理，传入类型、创建代理的对象以及方法名称<br />TestDelegate&nbsp;&nbsp; method&nbsp;&nbsp; =&nbsp;&nbsp; (TestDelegate)Delegate.CreateDelegate(t,obj,”GetValue”);<br />String&nbsp;&nbsp; returnValue&nbsp;&nbsp; =&nbsp;&nbsp; method(“hello”);</p>
<p>到这里，我们简单的讲述了反射的作用以及一些基本的用法，还有很多方面没有涉及到，有兴趣的朋友可以参考MSDN。</p>
<p><strong>c#中的反射　作者： YAOTIEBING<br /></strong>反射的概述&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射的定义：审查元数据并收集关于它的类型信息的能力。元数据（编译以后的最基本数据单元）就是一大堆的表，当编译程序集或者模块时，编译器会创建一个类定义表，一个字段定义表，和一个方法定义表等，。System.reflection命名空间包含的几个类，允许你反射（解析）这些元数据表的代码&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 和反射相关的命名空间（我们就是通过这几个命名空间访问反射信息）：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; System.Reflection.MemberInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.EventInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.FieldInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.MethodBase&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.ConstructorInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.MethodInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.PropertyInfo&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Type&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; System.Reflection.Assembly&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射的层次模型：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZGV2LmNzZG4ubmV0L0RldmVsb3AvQXJ0aWNsZUltYWdlcy8yOC8yODU0MS9DU0ROX0Rldl9JbWFnZV8yMDA0LTYtMjE1MTMwNzAuanBn.jpg">&nbsp;<br />&nbsp; 注：层次间都是一对多的关系&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射的作用：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． 可以使用反射动态地创建类型的实例，将类型绑定到现有对象，或从现 有对象中获取类型&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． 应用程序需要在运行时从某个特定的程序集中载入一个特定的类型，以便实现某个任务时可以用到反射。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3． 反射主要应用与类库，这些类库需要知道一个类型的定义，以便提供更多的功能。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 应用要点：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． 现实应用程序中很少有应用程序需要使用反射类型&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． 使用反射动态绑定需要牺牲性能&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3． 有些元数据信息是不能通过反射获取的&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 4． 某些反射类型是专门为那些clr 开发编译器的开发使用的，所以你要意识到不是所有的反射类型都是适合每个人的。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射appDomain 的程序集&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; 当你需要反射AppDomain 中包含的所有程序集，示例如下：&nbsp;<br />&nbsp;&nbsp; static void Main&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //通过GetAssemblies 调用appDomain的所有程序集&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; foreach (Assembly assem in Appdomain.currentDomain.GetAssemblies())&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //反射当前程序集的信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; reflector.ReflectOnAssembly(assem)&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 说明：调用AppDomain 对象的GetAssemblies 方法 将返回一个由System.Reflection.Assembly元素组成的数组。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射单个程序集&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 上面的方法讲的是反射AppDomain的所有程序集，我们可以显示的调用其中的一个程序集，system.reflecton.assembly 类型提供了下面三种方法：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． Load 方法：极力推荐的一种方法，Load 方法带有一个程序集标志并载入它，Load 将引起CLR把策略应用到程序集上，先后在全局程序集缓冲区，应用程序基目录和私有路径下面查找该程序集，如果找不到该程序集系统抛出异常&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． LoadFrom 方法：传递一个程序集文件的路径名（包括扩展名），CLR会载入您指定的这个程序集，传递的这个参数不能包含任何关于版本号的信息，区域性，和公钥信息，如果在指定路径找不到程序集抛出异常。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3． LoadWithPartialName：永远不要使用这个方法，因为应用程序不能确定再在载入的程序集的版本。该方法的唯一用途是帮助那些在.Net框架的测试环节使用.net 框架提供的某种行为的客户，这个方法将最终被抛弃不用。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 注意：system.AppDomain 也提供了一种Load 方法，他和Assembly的静态Load 方法不一样，AppDomain的load 方法是一种实例方法，返回的是一个对程序集的引用，Assembly的静态Load 方发将程序集按值封装发回给发出调用的AppDomain.尽量避免使用AppDomain的load 方法&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 利用反射获取类型信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 前面讲完了关于程序集的反射，下面在讲一下反射层次模型中的第三个层次，类型反射&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 一个简单的利用反射获取类型信息的例子：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; using system;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; using sytem.reflection;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; class reflecting&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; static void Main(string[]args)&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; reflecting reflect=new reflecting();//定义一个新的自身类&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //调用一个reflecting.exe程序集&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; assembly myAssembly =assembly.loadfrom(“reflecting.exe”)&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; reflect.getreflectioninfo(myAssembly);//获取反射信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; //定义一个获取反射内容的方法&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; void getreflectioninfo(assembly myassembly)&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; type[] typearr=myassemby.Gettypes();//获取类型&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; foreach (type type in typearr)//针对每个类型获取详细信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //获取类型的结构信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; constructorinfo[] myconstructors=type.GetConstructors;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //获取类型的字段信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; fieldinfo[] myfields=type.GetFiedls()&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //获取方法信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; MethodInfo myMethodInfo=type.GetMethods();&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //获取属性信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; propertyInfo[] myproperties=type.GetProperties&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; //获取事件信息&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; EventInfo[] Myevents=type.GetEvents;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 其它几种获取type对象的方法：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． System.type 参数为字符串类型，该字符串必须指定类型的完整名称（包括其命名空间）&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． System.type 提供了两个实例方法：GetNestedType,GetNestedTypes&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3． Syetem.Reflection.Assembly 类型提供的实例方法是：GetType,GetTypes,GetExporedTypes&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 4． System.Reflection.Moudle 提供了这些实例方法：GetType,GetTypes,FindTypes&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 设置反射类型的成员&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; 反射类型的成员就是反射层次模型中最下面的一层数据。我们可以通过type对象的GetMembers 方法取得一个类型的成员。如果我们使用的是不带参数的GetMembers，它只返回该类型的公共定义的静态变量和实例成员，我们也可以通过使用带参数的GetMembers通过参数设置来返回指定的类型成员。具体参数参考msdn 中system.reflection.bindingflags 枚举类型的详细说明。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 例如：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; //设置需要返回的类型的成员内容&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; bindingFlags bf=bingdingFlags.DeclaredOnly|bingdingFlags.Nonpublic|BingdingFlags.Public;&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; foreach (MemberInfo mi int t.getmembers(bf))&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; {&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp; writeline(mi.membertype) //输出指定的类型成员&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; }&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 通过反射创建类型的实例&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 通过反射可以获取程序集的类型，我们就可以根据获得的程序集类型来创建该类型新的实例，这也是前面提到的在运行时创建对象实现晚绑定的功能&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 我们可以通过下面的几个方法实现：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． System.Activator 的CreateInstance方法。该方法返回新对象的引用。具体使用方法参见msnd&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． System.Activator 的createInstanceFrom 与上一个方法类似，不过需要指定类型及其程序集&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3． System.Appdomain 的方法：createInstance,CreateInstanceAndUnwrap,CreateInstranceFrom和CreateInstraceFromAndUnwrap&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 4． System.type的InvokeMember实例方法：这个方法返回一个与传入参数相符的构造函数，并构造该类型。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 5． System.reflection.constructinfo 的Invoke实例方法&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射类型的接口&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 如果你想要获得一个类型继承的所有接口集合，可以调用Type的FindInterfaces GetInterface或者GetInterfaces。所有这些方法只能返回该类型直接继承的接口，他们不会返回从一个接口继承下来的接口。要想返回接口的基础接口必须再次调用上述方法。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 反射的性能：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 使用反射来调用类型或者触发方法，或者访问一个字段或者属性时clr 需 要做更多的工作：校验参数，检查权限等等，所以速度是非常慢的。所以尽量不要使用反射进行编程，对于打算编写一个动态构造类型（晚绑定）的应用程序，可以采取以下的几种方式进行代替：&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 1． 通过类的继承关系。让该类型从一个编译时可知的基础类型派生出来，在运行时生成该类 型的一个实例，将对其的引用放到其基础类型的一个变量中，然后调用该基础类型的虚方法。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 2． 通过接口实现。在运行时，构建该类型的一个实例，将对其的引用放到其接口类型的一个变量中，然后调用该接口定义的虚方法。&nbsp;<br />&nbsp;&nbsp;&nbsp;<br />&nbsp; 3．通过委托实现。让该类型实现一个方法，其名称和原型都与一个在编译时就已知的委托相符。在运行时先构造该类型的实例，然后在用该方法的对象及名称构造出该委托的实例，接着通过委托调用你想要的方法。这个方法相对与前面两个方法所作的工作要多一些，效率更低一些</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 10:55:31 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/data/" title="data">data</a>, <a href="https://www.biecuoliao.com/tag/roc/" title="roc">roc</a>, <a href="https://www.biecuoliao.com/tag/%e5%b7%a5%e4%bd%9c/" title="工作">工作</a>, <a href="https://www.biecuoliao.com/tag/images/" title="images">images</a>, <a href="https://www.biecuoliao.com/tag/%e6%a3%80%e6%9f%a5/" title="检查">检查</a>, <a href="https://www.biecuoliao.com/tag/%e4%be%8b%e5%ad%90/" title="例子">例子</a>, <a href="https://www.biecuoliao.com/tag/pes/" title="pes">pes</a>, <a href="https://www.biecuoliao.com/tag/arm/" title="arm">arm</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%9b%e5%bb%ba%e7%b1%bb%e5%9e%8b/" title="创建类型">创建类型</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#中反射的概念及其使用（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q7eyL0.html" rel="bookmark">JAVA进阶之旅（二）&mdash;&mdash;认识Class类，反射的概念，Constructor，Fiald，Method，反射Main方法，数组的反射和实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JAVA进阶之旅(二)--认识Class类,反射的概念,Constructor,Fiald,Method,反射Main方法,数组的反射和实践 我们继续聊JAVA,这次比较有意思,那就是反射了 一.认识Class类 想要反射,你就必须要了解一个类--Class,我们知道,java程序中的各个java类都属于同一事物,我们通常用Classliability描述对吧,反射这个概念从JDK1.2就出来了,历史算是比较悠久了,这个Class可不是关键字哦,这个是一个类,他代表的是一类事物: 我们归根结底就			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35p1zn0.html" rel="bookmark">java中反射机制原理讲解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				﻿﻿ 反射,当时经常听他们说,自己也看过一些资料,也可能在设计模式中使用过,但是感觉对它没有一个较深入的了解,这次重新学习了一下,感觉还行吧! 一,先看一下反射的概念: 主要是指程序可以访问,检测和修改它本身状态或行为的一种能力,并能根据自身行为的状态和结果,调整或修改应用所描述行为的状态和相关的语义. 反射是Java中一种强大的工具,能够使我们很方便的创建灵活的代码,这些代码可以再运行时装配,无需在组件之间进行源代码链接.但是反射使用不当会成本很高! 看概念很晕的,继续往下看. 二,反射机制的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzDZ8J3.html" rel="bookmark">OC中协议的概念以及用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OC中协议的概念以及用法,协议也是OC中的一个重点,Foundation框架以及我们后面在写代码都会用到. OC中的协议就是相当于Java中的接口(抽象类),只不过OC中的名字更形象点,因为我们在学习Java中的接口时候,看可以知道其实接口就相当于一种契约(协议),给他的实现类打上标记了,当然这个活在Java5.0之后,被注解替代了,因为注解就是为了此功能诞生的.协议就是定义了一组方法,然后让其他类去实现 下面来看代码:WithProtocol.h[objc]  view plaincopy 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQrZN3.html" rel="bookmark">Java语言中反射动态代理接口的解释与演示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java语言中反射动态代理接口的解释与演示 Java在JDK1.3的时候引入了动态代理机制.可以运用在框架编程与平台编程时候捕获事件.审核数据.日志等功能实现,首先看一下设计模式的UML图解: 当你调用一个接口API时候,实际实现类继承该接口,调用时候经过proxy实现. 在Java中动态代理实现的两个关键接口类与class类分别如下: java.lang.reflect.Proxy java.lang.reflect.InvocationHandler 我们下面就通过InvocationHan			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5Jvv0.html" rel="bookmark">java中反射学习整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明:http://blog.csdn.net/j903829182/article/details/38405735 反射主要是指程序可以访问,检测和修改它本身的状态或行为的一种能力. java中反射是一种强大的工具,它能够创建灵活的代码,这些代码可以在运行时装载,无须在组件之间进行链接.反射允许在编写与执行时,使程序能够接入到jvm中的类的内部信息,而不是源代码中选定的类协作的代码.这使反射成为构建灵活应用代码的主要工具.需要注意的是,如果使用不当,反射的成本会很高. package			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEoGex3.html" rel="bookmark">数据库中一些基本概念的深入理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.怎样理解事务的一致性 一致性就是一个这样的东西,一致性对于不同的应用领域有着不同的定义,因为它就是按照业务规则来说明这个是一致的,那个是不一致的,这个角度上讲,一致性就是一个系统的状态,一个合理的状态.而合理则表现在这个状态是否符合业务规则.例如:转账业务中合理的状态就是,转出和转入帐户必须出入相等,如果不等那就意味着不合理,也就是不一致,有时候我们很容易就能把它定为&quot;守恒一致性&quot;,也就是说总体来说什么也不多,什么也不少就是一致性.而这个规则能够使用于其他的义务吗?我们不能说不能,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lXgOb0.html" rel="bookmark">Python中类型的概念（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本课程主要介绍6种Python语言中的类型:数字类型.字符串类型.元组类型.列表类型文件类型.字典类型 1.数字类型 Python语言包括三种数字类型:整数类型.浮点数类型.复数类型 (1)整数类型 与数学中的整数概念一致,没有取值范围限制 pow(x, y)函数:计算xy. (通过指数函数,可以看出,python语言整数类型没有范围限制) (0x, 0X开头表示16进制数) (0b, 0B开头表示2进制数 ) (0o, 0O开头表示8进制数) (2)浮点数类型 带有小数点及小数的数字 Pyth			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MB12Dg4.html" rel="bookmark">javascript &lpar;js&rpar;中的基本概念</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 基本数据类型 1.1 number (数字)在js中没有整形和浮点型的区分,所有的数字都是浮点型标识, 采用64位的浮点格式来表示数字.如果数字类型用在字符串连接表达式中,则会自动转换成字符串, 在JS中表示16进制通过在数字前加&quot;0x&quot;或&quot;0X&quot;(零). 1.2 string (字符串)字符串类型是实用单引号('')或双引号(&quot;&quot;)括起来的unicode字符序列, 一些特殊的字符可以通过转义符来标识.如果字符串用在数字表达式环境中,字符串			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NzmO24.html" rel="bookmark">java中反射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				反射 避免硬编码 类对象 (存储了类的信息的对象 类加载的产物) Class 类名.class 直接获得类对象 (简单类型的类对象 int.class) 类的对象.getClass() Class.forName(&quot;类名&quot;) 通过类名主动加载一个类并获得类对象 类对象.newInstance() 创建类的对象 java中反射,布布扣,bubuko.com			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47J913.html" rel="bookmark" class="title">servlet笔记</a>
					<div>
						开发servlet有三种方法: (1)    实现 Servlet接口 (2)    通过继承 GenericServlet (3)    通过继承 HttpServlet get提交和post提交的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXYVp3.html" rel="bookmark" class="title">Citrix每周技术动态-20160716</a>
					<div>
						XenApp/XenDesktop 下载最新的UPM 5.4.1版本 链接:https://www.citrix.com/downloads/xenapp/components/profile-man ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5YPn3.html" rel="bookmark" class="title">Extjs 表单提交送给新手</a>
					<div>
						Extjs的三种提交方式: 表单Ajax提交,普通提交,单独Ajax提交: 1.表单ajax提交(默认提交方式) 提交函数:当按下表单中的提交按钮时执行下面的btn函数,按照表单的name进行提交.提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8k5Z0.html" rel="bookmark" class="title">教你3步免积分下载门素材网页特效无需工具</a>
					<div>
						比如你要下载这个效果,可是积分太贵了,怎么办? 教你免积分下载(此方法仅供学习,建议大家尊重别人的劳动成果,付费购买,谢谢!) 第一步: 找到你要下载的JS特效或者其它 第二步,用火狐或者谷歌审查元素 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rv8db3.html" rel="bookmark" class="title">jQuery数据类型总结</a>
					<div>
						jQuery除了包含原生JS中的内置数据类型(built-in datatype),还包括一些扩展的数据类型(virtual types),如Selectors.Events等. 1. String  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvknX0.html" rel="bookmark" class="title">Linux&sol;redhat 基本网络配置</a>
					<div>
						本文转自:http://www.cnblogs.com/kerrycode/archive/2012/12/17/2821836.html#commentform 配置动态IP 在终端命令窗口中输入s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYgDB3.html" rel="bookmark" class="title">华为OSPF动态路由原理</a>
					<div>
						原理: 邻居关系: ospf的5种报文: ospf的7种状态: ospf的6中LSA					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v5LeZ0.html" rel="bookmark" class="title">使用Leopard Redis</a>
					<div>
						使用Leopard Redis 学习如何在使用Leopard Redis. 本指南将引导您使用Leopard Redis操作Redis. How to complete this guide 你可以从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9B874.html" rel="bookmark" class="title">bzoj4276</a>
					<div>
						线段树优化建图+费用流 朴素的做法是每个强盗直接对每个区间的每个点连边,然后跑最大权匹配,这样有5000*5000条边,肯定过不去,那么我们用线段树优化一下,因为线段树能把一个O(n)的区间划分为O( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49koo10.html" rel="bookmark" class="title">AJAX-----11iframe模拟ajax文件上传效果原理3</a>
					<div>
						如果直接给用户提示上传成功,那么如果用户上传的文件比较大点,那么等上半天都没反映,那么用户很有可能会刷新或者关了从来等... 那么会给我们服务器带来一定的影响,所以我们可以对这方面的用户体验度进行提升 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvyA2M.html" rel="bookmark" class="title">事件继承，避免重复注册注意事项</a>
					<div>
						BaseForm: 1 /** 2 * 基本表单类 3 */ 4 Ext.define(&quot;Lms.view.BaseForm&quot;, { 5 extend : &quot;Ext.fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZakXd0.html" rel="bookmark" class="title">Python学习基础篇&mdash;文件操作和集合</a>
					<div>
						这篇博客来说一下python对文件的操作. 对文件的操作分三步: 1.打开文件获取文件的句柄,句柄就理解为这个文件 2.通过文件句柄操作文件 3.关闭文件. 现有以下文件file.txt: 我们哭了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXAvaM.html" rel="bookmark" class="title">《DSP using MATLAB》示例9&period;1</a>
					<div>
						前段时间发生许多事,主要是楼盘开发商资金链紧张,无法通过验收,拿不到两书一表(住宅质量保证书.住宅使用说明书.房屋建筑工程竣工验收备案表), 各种配套设施都没有,就在这条件下还强制我们业主收房,心塞, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49OZ5b0.html" rel="bookmark" class="title">IOS开发UI篇--一个侧滑菜单SlidingMenu</a>
					<div>
						一.简介 侧滑菜单已经成为app一个极常用的设计,不管是事务类,效率类还是生活类app.侧滑菜单因Path 2.0和Facebook为开发者熟知,国内目前也有很多流行app用到了侧滑菜单,比如QQ.网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3w5BV1M.html" rel="bookmark" class="title">题目2 &colon; 展胜地的鲤鱼旗 &lpar;hihoCoder挑战赛20&Tab;&rpar;</a>
					<div>
						题目2 : 展胜地的鲤鱼旗 时间限制:10000ms 单点时限:1000ms 内存限制:256MB 描述 岩手县北上市的「北上市立公园展胜地」,是陆奥国三大樱花名所之一.每年的四月中旬到五月初,这里都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoXoEx0.html" rel="bookmark" class="title">EF&period;Reverse&period;POCO&period;Core&period;ttinclude&amp;quot&semi;</a>
					<div>
						1 &lt;#@ include file=&quot;EF.Reverse.POCO.Core.ttinclude&quot; #&gt; 2 &lt;# 3 // v2.18.1 4 // Ple ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q89Yp0.html" rel="bookmark" class="title">hdu 4022 STL</a>
					<div>
						题意:给你n个敌人的坐标,再给你m个炸弹和爆炸方向,每个炸弹可以炸横排或竖排的敌人,问你每个炸弹能炸死多少个人. 1 /* 2 HDU 4022 3 G++ 1296ms 4 5 6 */ 7 8 9 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm7qE13.html" rel="bookmark" class="title">关于Stream的Read方法</a>
					<div>
						一次做到一个关于使用DataContractJsonSerializer类的表述.其中需要用到MemoryStream数组读取.发生数组溢出错误,这里特记录一笔: public static clas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEqdB1M.html" rel="bookmark" class="title">C&num;人脸识别</a>
					<div>
						C#百度人脸识别 最近看到一只我家徒儿发来的链接,原来是一堆百度AI的SDK,于是一时兴起就做了一只人脸识别,喵喵喵(●'?'●) 一.准备工作 首先,当然是下载SDK啦:http://ai.baid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6nJyvM.html" rel="bookmark" class="title">关于JQUERY的AJAX跨域问题</a>
					<div>
						项目中使用了AJAX跨域获取数据,上传后有很多反应获取不到数据.查看了,现在公司内部有40%以上的人使用的浏览器内核为IE7.当时以为只是浏览器兼容问题,通过各种测试手段,就是不报错.后来忽然想起来是 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
